local M = {}

local helper = require('scenario/scenariohelper') --??? Straight from bank_robbery.lua, no idea if this is all I need to do
--local transitMarker = require('scenario/transit_marker') -- Import(? Seems equivalent to that) our transit_marker.lua module
local running = false --??? Straight from bank_robbery.lua, no idea if this is all I need to do
local scenario = nil --??? Straight from bank_robbery.lua, no idea if this is all I need to do
local player -- For functions like player:getPosition

local checkForTriggerEntry = false --Ensure that the driver stops at stage starts/ends for timing purposes
local checkForSpeeding = false --Ensure that the driver's average speed during transit stages is less than 60mph (26.83m/s)

--local maxCarDamage = 14000 --Ensure that the driver can keep on driving (unsure of what these numbers come from, 14k is 4x the limit in East Coast USA's Bank Robbery damage limit)
local transitMaximumAvgSpeed = 26.83 --m/s, equivalent to 60 mph
local avgSpeed = 0 
local speeds = {} --A table that will hold all of our collected speeds during transit, maths will be done to get the avgSpeed

local stageStarts = {'stage1_Start', 'stage2_Start','Stage3_Start'} -- For timing purposes
local stageEnds = {'stage1_End','stage2_End','Stage3_End'}
local stageTimes = {0,0,0}
local stageTiming = false -- Are we currently timing to the stageTimes[currentStage]?
local stageStarted = false -- Has the stage actually started (to get the current scenario.time for accurate timing)
local stageStartTime = 0 -- The scenario.time at which the stage started
local stageEnded = false -- Has the stage ended (for accurate timing)
local currentStage = 0 --Matches to stageTimes, for penalty/scoring purposes

local countdownStarted = false -- For counting down to start (no idea how to do the fancy hooking stuff that happens in race.lua's countdown)
local countdown = 0

local transitStarts = {'transit1_Start','transit2_Start','transit3_Start','Transit4_Start',} -- For timing purposes
local transitEnds = {'transit1_End','transit2_End','transit3_End','Transit4_End_DayEnd'}
--local transitTimes = {-1,-1,-1,-1}

local currentWaypoint  
local nextWaypoint
local currentWaypointName = 'transit1_Start'
local nextWaypointName = 'transit1_Start1'
local currentWaypointIndex = 1
local nextWaypointIndex = 2
local triggerPosition 
local triggerRadiusSq 
local enteredStageTrigger = false
local isTransitStart = false
local isStageStart = false
local isStageEnd = false

local firstMsgDisplayed = false
local shortCountdown = 0 --A kludge to let us display something after the initial race countdown because for some reason guihooks.trigger('ScenarioFlashMessageReset') does nothing at all
local msgCountdown = 0 --A kludge to ensure that messages get fully displayed

local targetName = 'Transit4_End_DayEnd' --To end the event

local messageDisplayed = true

local function reset()
    checkForSpeeding = false
    checkForTriggerEntry = false
    running = false
    stageTimes = {0,0,0}
    --transitTimes = {-1,-1,-1,-1}
end

-- called when countdown finished
local function onRaceStart()
    reset()
    running = true
    messageDisplayed = false
    helper.trackVehicle('scenario_player0', 'car')
    dump(scenario.lapConfig[nextWaypointIndex])
    nextWaypointName = scenario.lapConfig[nextWaypointIndex]
end

--Simple generic array (aka table in Lua?) search
local function has_value(tab, val)
    for index, value in ipairs(tab) do
        if value == val then
            return true
        end
    end
    return false
end

--Simple sum array function
local function sum(tab)
    local sum = 0
    for index, value in ipairs(tab) do
        sum = sum + value
    end
    return sum
end

--Simple clear array function
local function zeroTable(tab)
    for index,value in ipairs(tab) do 
        tab[value]=nil 
    end
    return tab
end

local function setTrigger(pos, rad)
    triggerPosition = pos
    triggerRadiusSq = rad * rad
end

local function checkTrigger()
    if triggerPosition then
        local pos = vec3(player:getPosition())
        --dump(pos)
        if pos:squaredDistance(triggerPosition) < triggerRadiusSq then
            --triggerPosition = nil
            --triggerRadiusSq = nil
            return true
        else
            return false
        end
    else
        return false
    end
end

--Copied straight from bank_robbery.lua, modified to collect and display 3 times as well as the overall time (could make it display any n number of times with some effort, gonna need to for more of these scenarios)
local function success()
    -- Needs to display individual stage times as well as overall (stages only) time
    local totalTime = 0
    local totalTimeStr = ''
    local timeStr = {'','',''}
    for index,value in ipairs(stageTimes) do 
        totalTime = totalTime + stageTimes[index]
        local minutes = math.floor(stageTimes[index] / 60)
        local seconds = stageTimes[index] - (minutes * 60)
        if minutes > 0 then
            timeStr[index] = string.format("%02.0f:%05.3f", minutes, seconds)
        else
            timeStr[index] = string.format("%0.3f", seconds) .. 's'
        end
    end
    local minutes = math.floor(totalTime / 60)
    local seconds = totalTime - (minutes * 60)
    if minutes > 0 then
        totalTimeStr = string.format("%02.0f:%05.3f", minutes, seconds)
    else
        totalTimeStr = string.format("%0.3f", seconds) .. 's'
    end
    local result = {msg = 'Well Done!\n Stage 1: '..timeStr[1]..',\n Stage 2: '..timeStr[2]..',\n Stage 3: '..timeStr[3]..',\n Total Time: '..totalTimeStr} --\n doesn't actually cause a new line on the results menu, I keep it here in the hope that one day it does
    scenarios.finish(result)
    reset()
end

-- data { vehicleName = 'string', waypointName = 'string' }
local function onRaceWaypoint( data )
    dump(data)
    if data.waypointName == targetName then--targetName is goal, others are debug
        success()
    end
    

    --Keep track of which waypoints we're at (current (orange) and next (grey))
    if data.cur > currentWaypointIndex - 1 then
        currentWaypointIndex = nextWaypointIndex
        nextWaypointIndex = nextWaypointIndex + 1
    end
    nextWaypointName = scenario.lapConfig[nextWaypointIndex]
    nextWaypoint = scenario.nodes[nextWaypointName]

    currentWaypointName = scenario.lapConfig[currentWaypointIndex]
    currentWaypoint = scenario.nodes[currentWaypointName]

    --dump(scenario)
    --dump(scenario.nodes)
    --[[dump(scenario.nodes[nextWaypointName])
    dump(scenario.nodes[nextWaypointIndex])
    
    dump(currentWaypointIndex)
    dump(currentWaypointName)
    dump(currentWaypoint)
    dump(nextWaypointIndex)
    dump(nextWaypointName)
    dump(nextWaypoint)]]

    if has_value(transitStarts, currentWaypointName) then
        setTrigger(currentWaypoint.pos, currentWaypoint.radius)
        isTransitStart = true
        isStageStart = false
        isStageEnd = false
        stageEnded = true
        checkForTriggerEntry = true
        dump('Set Trigger for Transit Start')
    elseif has_value(stageStarts, currentWaypointName) then
        setTrigger(currentWaypoint.pos,currentWaypoint.radius)
        isTransitStart = false
        isStageStart = true
        isStageEnd = false
        stageEnded = true
        checkForTriggerEntry = true
        dump('Set Trigger for Stage Start')
    elseif has_value(stageEnds, currentWaypointName) then
        setTrigger(currentWaypoint.pos, currentWaypoint.radius)
        isTransitStart = false
        isStageStart = false
        isStageEnd = true
        stageEnded = false
        checkForTriggerEntry = false
        dump('Set Trigger for Stage End')
    end
end

--Copied straight from bank_robbery.lua, no modifications (yet)
local function fail( reason )
    scenarios.finish({failed = reason})
    reset()
end

local function displayMessage(msg, dur, big)
    if not messageDisplayed then
        messageDisplayed = true
        guihooks.trigger('ScenarioFlashMessageReset')
        helper.flashUiMessage(msg, dur, big)
    end
end

-- called before rendering a graphics frame (so much more often than onRaceTick, great for a timer!)
local function onPreRender(dt)

    if scenario == nil then return end
    
    if scenario.state == 'running' and be:getEnabled() then
        -- Countdown to start of stage (once we're doing that)
        if countdownStarted then
            countdown = countdown + dt --If any errors they'll probably be here, maybe
            if countdown > 5 then -- Normal start
                guihooks.trigger('ScenarioFlashMessageReset')
                helper.flashUiMessage('GO!',1,true) --This could be an issue too
                stageTiming = true
                stageEnded = false
                enteredStageTrigger = false
                checkForTriggerEntry = false
                countdownStarted = false
                countdown = 0
                messageDisplayed = true
                currentStage = currentStage + 1 -- += doesn't exist so I'm guessing ++ doesn't either
            elseif carSpeed > 2 then -- Jump start check
                stageEnded = false
                stageTiming = true
                guihooks.trigger('ScenarioFlashMessageReset')
                helper.flashUiMessage('Jump Start! +15 sec', 5)
                stageTimes[currentStage] = stageTimes[currentStage] + 15
                enteredStageTrigger = false
                checkForTriggerEntry = false
                countdownStarted = false
                countdown = 0
                messageDisplayed = true
                currentStage = currentStage + 1 -- += doesn't exist so I'm guessing ++ doesn't either
            end
            dump(countdown)
        end

        -- Stage timing, simple diff from the scenario.timer time at which we started and the scenario.timer time at which we finished. Hopefully very precise now that it's sitting in the prerenderer.
        if stageTiming then
            if not stageStarted then
                stageStarted = true
                stageStartTime = scenario.timer
                dump('Set stageStartTime:'..stageStartTime)
            elseif stageEnded then
                stageTimes[currentStage] = stageTimes[currentStage] + (scenario.timer - stageStartTime)
                stageTiming = false
                stageEnded = false
                dump('Stage Time:'..stageTimes[currentStage])
                dump('Scenario Time:'..scenario.timer)
            end
        end
    end
end

-- called every 250ms. Use "status.setScenarioFailed()" for return failed test
-- data { dTime = number }
local function onRaceTick(raceTickTime)
    if not running then
        return true
    end

    local carData = map.objects.car
    local pos = vec3(player:getPosition())

    if not carData then
        return
    end
    --dump(carData)
    local carSpeed = carData.vel:length()

    -- Record the car's speed every 250ms (when it is above a minimum speed so speeding cant be gamed)
    -- Could do interesting stuff with setting the minimum counted speed to something related to the vehicle's max recorded speed (like minCountedSpeed = maxSpeed/2) during the current transit, but that sounds like a bit of work
    if checkForSpeeding and carSpeed > 22 then --22m/s sec, around 50 mph/79 km/h, Avoids getting bad data from the car sitting still at CPs/getting up to speed
        speeds[#speeds+1] = carSpeed
    end

    --dump(carSpeed)
    --[[if carData.damage > maxCarDamage then -- The car is totaled when the driver thinks its totaled. Frankly the damage value is worthless, there's probably a better way to figure this out (basically, if the car has no drive to the wheels or broken engine then fail) but idk enough to do it
        fail('Car is totaled')
    end]]
    --dump(nextWaypoint)-- currentWaypointIndex currentWaypoint nextWaypointIndex)

    --This doesn't work quite right, penalties from transit in the final transit won't be assigned properly
    --[[if stageTiming and has_value(transitStarts, currentWaypointName)
        stageTiming = false
        currentStage = currentStage + 1 -- += doesn't exist so I'm guessing ++ doesn't either
    end]]

    -- Find out when we enter the checkpoint trigger
    if checkForTriggerEntry then
        --local pos = vec3(player:getPosition())
        --dump('Player Pos: '..pos)
        if scenario.state == 'running' and be:getEnabled() then
            if checkTrigger() and not enteredStageTrigger then
                enteredStageTrigger = true
                dump('Player Entered Trigger')
                guihooks.trigger('ScenarioFlashMessageReset')
                helper.flashUiMessage('Stop!', 1, true)
                msgCountdown = 4 --Shorten our msgCountdown display to 1 sec, should work hopefully
                messageDisplayed = true
            end
        end
    end

    -- The bulk of the race logic, handles everything except interrupt style messages (Stop! and Jump Start!)
    -- It's very messy and the amount of bool flags could(should) probably be cleaned up quite a bit
    if messageDisplayed == false then -- Ensure that we're only displaying one message at a time (because it doesn't queue messages)
        --[[What's in here in no particular order:
        1 Starter Message 
        2 Stage ended, time given, slow down to stop at next CP (is transit) 
        3 Stop at next CP (is stage start) 
        4 Sped during transit, penalty 
        5 Entered CP, Stop 
        6 Blew through CP, penalty (is transit) 
        7 Blew through CP, penalty (is stage start) 
        8 Stopped at CP, continue (is transit) 
        9 Stopped at CP, race countdown (is stage start) 
        ]]
        if currentWaypointIndex == 1 and firstMsgDisplayed == false then -- 1 Starter Message | conditions: firstCheckpoint
            shortCountdown = shortCountdown + raceTickTime --kludge to make sure we actually display this message and it isn't blocked by the game's starting countdown timer (even though it should have ended or we should have reset the flash messages but whatever)
            if shortCountdown > 1 then
                guihooks.trigger('ScenarioFlashMessageReset')
                helper.flashUiMessage('Drive to the first control zone and stop to begin the first road section!', 5)
                checkForTriggerEntry = true
                checkForSpeeding = true
                messageDisplayed = true
                firstMsgDisplayed = true
                dump('Start Message Displaying')
            end
        elseif enteredStageTrigger then -- 5 Entered CP | conditions: enteredStageTrigger
            if isTransitStart then -- Make sure that user comes to a halt within the checkpoint trigger for transits
                if not checkTrigger() then --6 Blew through CP, penalty (is transit) | conditions: enteredTrigger and not checkTrigger() and isTransitStart
                    guihooks.trigger('ScenarioFlashMessageReset')
                    guihooks.trigger('ScenarioFlashMessage',{{'Blew through control zone! +60 seconds', 5}})
                    messageDisplayed = true
                    enteredStageTrigger = false
                    checkForTriggerEntry = false
                    checkForSpeeding = true
                    stageTimes[currentStage] = stageTimes[currentStage] + 60 --Penalty for blowing time control
                    dump('Blew Through CP (Transit) Displaying')
                elseif carSpeed < 0.01 then -- 8 Stopped at CP, continue (is transit) | conditions: enteredTrigger and carSpeed < 0.1 and isTransitStart
                    guihooks.trigger('ScenarioFlashMessageReset')
                    guihooks.trigger('ScenarioFlashMessage',{{'Continue Road Section', 5}})
                    messageDisplayed = true
                    enteredStageTrigger = false
                    checkForTriggerEntry = false
                    checkForSpeeding = true
                    dump('Continue from CP (Transit) Displaying')
                end
            elseif isStageStart then  -- Make sure that user comes to a halt within the checkpoint trigger for stage starts
                if not checkTrigger() then -- 7 Blew through CP, penalty (is stage start) | conditions: enteredTrigger and not checkTrigger() and isStageStart
                    guihooks.trigger('ScenarioFlashMessageReset')
                    guihooks.trigger('ScenarioFlashMessage',{{'Blew through control zone! +75 seconds', 5}}) 
                    messageDisplayed = true
                    enteredStageTrigger = false
                    checkForTriggerEntry = false
                    checkForSpeeding = false
                    stageTimes[currentStage] = stageTimes[currentStage] + 75 --Penalty for blowing time control (extra 15 seconds for jumping the start)
                    dump('Blew Through CP (Stage) Displaying')
                elseif carSpeed < 0.01 and countdownStarted == false then -- 9 Stopped at CP, race countdown (is stage start) | conditions: enteredTrigger and carSpeed < 0.1 and isStageStart
                    countdownStarted = true
                    guihooks.trigger('ScenarioFlashMessageReset')
                    guihooks.trigger('ScenarioFlashMessage', {{'4..',1,true},{'3..',1,true},{'2..',1, true},{'1..',1, true}})
                    messageDisplayed = true
                    enteredStageTrigger = false
                    checkForTriggerEntry = false
                    checkForSpeeding = false
                    dump('Countdown for Stage Start Displaying')
                end
            end
        elseif has_value(stageStarts, currentWaypointName) then -- 3 Stop at next CP (is stage start) | conditions: has_value(stageStarts, currentWaypointName)
            --First do maths to find out if we were speeding or not
            avgSpeed = sum(speeds) / #speeds 
            dump('avgSpeed: '..avgSpeed..' transitMaximumAvgSpeed: '..transitMaximumAvgSpeed)
            if avgSpeed > transitMaximumAvgSpeed then -- 4 Sped during transit, penalty | conditions: has_value(stageStarts, currentWaypointName) and avgSpeed > speedLimit
                guihooks.trigger('ScenarioFlashMessageReset')
                helper.flashUiMessage('Stop at the control zone ahead to start the next stage! (Speeding Penalty +180 sec)', 5)
                stageTimes[currentStage] = stageTimes[currentStage] + 180
                checkForTriggerEntry = true
                checkForSpeeding = false
                messageDisplayed = true
                dump('Stop at next CP (Stage Start, Sped During Transit) Displaying')
            else
                guihooks.trigger('ScenarioFlashMessageReset')
                helper.flashUiMessage('Stop at the control zone ahead to start the next stage!', 5)
                checkForTriggerEntry = true
                checkForSpeeding = false
                messageDisplayed = true
                dump('Stop at next CP (Stage Start) Displaying')
            end
        elseif currentWaypointIndex > 1 and has_value(transitStarts, currentWaypointName) then --2 Stage ended, time given, slow down to stop at next CP (is transit) | conditions: not firstCheckpoint and has_value(transitStarts, currentWaypointName)
            stageStarted = false
            dump(stageTimes[currentStage])
            local timeStr = ''
            local minutes = math.floor(stageTimes[currentStage] / 60) --Build the time in a more legible format
            local seconds = stageTimes[currentStage] - (minutes * 60)
            if minutes > 0 then
                timeStr = string.format("%02.0f:%05.3f", minutes, seconds)
            else
                timeStr = string.format("%0.3f", seconds) .. 's'
            end
            guihooks.trigger('ScenarioFlashMessageReset')
            helper.flashUiMessage('Stage timing has ended (Time: '..timeStr..')! Stop at the control zone ahead.', 5)
            enteredStageTrigger = false
            checkForTriggerEntry = true
            checkForSpeeding = false
            messageDisplayed = true
            speeds = zeroTable(speeds)
            dump('Stage Ended, Timing and Slow Down To Stop Displaying')
        end
    end


    -- Message display countdown, needed to ensure that we aren't breaking the not-robust message system trying to queue up a ton of stuff (note: AFAICT there is no queueing at all)
    if messageDisplayed == true then
        msgCountdown = msgCountdown + raceTickTime
        --dump('msgCountdown:'..msgCountdown)
        if msgCountdown >= 5 then
            dump('msgCountdown Ticked Over, Ready For New msg?')
            messageDisplayed = false
            msgCountdown = 0
        end
    end
end

--Copied straight from bank_robbery.lua, no modifications (yet)
local function onScenarioChange(sc)
    scenario = sc

    if not scenario then return end

    if scenario.state == 'pre-start' then 
        player = scenetree.findObject('scenario_player0')
    end
end

-- public interface
M.onRaceStart = onRaceStart
M.onRaceWaypoint = onRaceWaypoint
M.onRaceTick = onRaceTick
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender

return M